Rem ********************************************************************************
Rem * Name      : DrawMusicCenterPlaylist.vbs
Rem * Version   : 1.1
Rem * Date      : 2018/03/11
Rem * Auther    : SIA
Rem * URL       : http://sia.blog4.fc2.com/
Rem ********************************************************************************
Rem * Version 1.0 
Rem * Version 1.1 _Ci~bNvCXgΉ
Rem ********************************************************************************
Option Explicit
Const ExtSplit = "flac dsd dff,mp3 m4a wma"     'vgqm3ut@Cʂɍ
'Const ExtSplit = ""                             'ȂȂ
Const CharSetMode = 2   '0:Shift_JIS 1:UTF-8(BOMt) 2:UTF-8(BOM)
Const REG_MDB_PATH = "HKEY_LOCAL_MACHINE\SOFTWARE\Sony Corporation\Music Center\Database\MetallicData"
Const ObjectSpecIdList = "1:vCXg,6:_Ci~bNvCXg"
Const adOpenForwardOnly = 0
Const adTypeBinary = 1              'oCif[^
Const adTypeText = 2                'lBCharsetŎw肳ꂽZbgɂeLXgf[^\܂B
Const adWriteChar = 0               'lBw肵eLXg݂܂B
Const adWriteLine = 1               't@CɏލہAeLXgƍs؂蕶݂܂B
Const adSaveCreateNotExist = 1      'lBw肵t@CȂꍇAVt@C쐬܂B
Const adSaveCreateOverWrite = 2     'w肵t@Cɑ݂ꍇA㏑܂B
Dim cn
Dim fso
Dim dicPlayListTitle
Dim DeleteDriveString
Call Main
Sub Main()
    Dim WSFullName
    Dim WSExePath
    Dim vnt
    Dim Args
    '64rbgŎsꍇ32rbgōĎs
    With CreateObject("WScript.Shell")
        WSFullName = WScript.FullName
        If (InStr(.ExpandEnvironmentStrings("%PROCESSOR_ARCHITECTURE%"), "64")) And (InStr(LCase(WSFullName), "system32")) Then
            With CreateObject("Scripting.FileSystemObject")
                WSExePath = .BuildPath(.GetSpecialFolder(0).Path, "SysWOW64")
                WSExePath = .BuildPath(WSExePath, .GetFileName(WSFullName))
                If Not .FileExists(WSExePath) Then
                    MsgBox WSExePath & "܂B", vbExclamation
                    Exit Sub
                End If
            End With
            Args = ""
            For Each vnt In WScript.Arguments
                Args = Args & " """ & vnt & """"
            Next
            .Run """" & WSExePath & """ """ & WScript.ScriptFullName & """" & Args
            Exit Sub
        End If
    End With
    Call MakePlayListMain
End Sub
Sub MakePlayListMain()
    Dim DbPath
    Dim tempDb
    Dim ScriptDir
    Dim OutputDir
    Dim strDateTime
    Dim msg
    Dim msgResult
    Dim vntKey
    Dim vntWk
    Dim ObjectId, ObjectName, ObjectSpecId, ObjectSpecName
    '
    Set fso = CreateObject("Scripting.FileSystemObject")
    With CreateObject("WScript.Shell")
        DbPath = .RegRead(REG_MDB_PATH)
    End With
    If Not fso.FileExists(DbPath) Then
        If MsgBox("MediaCenterDB܂Bf܂B", vbExclamation) Then
            Exit Sub
        End If
    End If
    msg = DbPath & "vCXg𒊏o܂B" & _
            vbCrLf & _
            vbCrLf & _
            "쐬m3ut@ChCu܂H"
    msgResult = MsgBox(msg, vbInformation + vbYesNoCancel)
    Select Case msgResult
        Case vbYes
            DeleteDriveString = True
        Case vbNo
            DeleteDriveString = False
        Case vbCancel
            MsgBox "f", vbInformation
            Exit Sub
    End Select
    'MDBRs[Ďgp
    ScriptDir = fso.GetParentFolderName(WScript.ScriptFullName)
    tempDb = fso.GetTempName()
    tempDb = fso.BuildPath(ScriptDir, tempDb)
    fso.CopyFile DbPath, tempDb, True
    'DBڑ
    Set cn = CreateObject("ADODB.Connection")
    'cn.Open "Driver={Microsoft Access Driver (*.mdb, *.accdb)}; DBQ=" & tempDb & ";"
    cn.Open "provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & tempDb & ";"
    'ێ
    strDateTime = Replace(Replace(Replace(Now(), "/", ""), ":", ""), " ", "_")
    'ObjectId,ObjectName𗭂ߍޘAzz
    Set dicPlayListTitle = CreateObject("Scripting.Dictionary")
    For Each vntWk In Split(ObjectSpecIdList, ",")
        ObjectSpecId = Split(vntWk, ":")(0)
        ObjectSpecName = Split(vntWk, ":")(1)
        'o͐tH_pX
        OutputDir = fso.BuildPath(ScriptDir, strDateTime)
        OutputDir = fso.BuildPath(OutputDir, ObjectSpecName)
        'vCXgꗗ擾
        dicPlayListTitle.RemoveAll
        Call GetPlayListTitle(ObjectSpecId)
        'vCXg1
        For Each vntKey In dicPlayListTitle.Keys
            ObjectId = vntKey
            ObjectName = dicPlayListTitle.Item(vntKey)
            Select Case CharSetMode
                Case 0: Call MakePlayList_ShiftJIS(ObjectId, ObjectName, OutputDir)
                Case 1: Call MakePlayList_UTF8(ObjectId, ObjectName, OutputDir)
                Case 2: Call MakePlayList_UTF8N(ObjectId, ObjectName, OutputDir)
            End Select
        Next
    Next
    'DBؒf
    cn.Close
    Set cn = Nothing
    'ꎞt@C̍폜
    If fso.FileExists(tempDb) Then
        fso.DeleteFile tempDb
    End If
    MsgBox "o͊", vbInformation
End Sub
Sub GetPlayListTitle(ObjectSpecId)
    Dim sql
    Dim ObjectId, ObjectName
    'R[hZbg擾
    sql = "SELECT ObjectId, ObjectName"
    sql = sql & " FROM q_syncSource"
    sql = sql & " WHERE ObjectSpecId = " & ObjectSpecId
    sql = sql & " ORDER BY ObjectName"
    With CreateObject("ADODB.Recordset")
        .Open sql, cn, adOpenForwardOnly
        Do While Not .EOF
            ObjectId = "" & .Fields("ObjectId").Value
            ObjectName = "" & .Fields("ObjectName").Value
            If dicPlayListTitle.Exists(ObjectId) Then
                MsgBox ObjectId & vbTab & ObjectName
            Else
                dicPlayListTitle.Add ObjectId, ObjectName
            End If
            .MoveNext
        Loop
        .Close
    End With
End Sub
Sub MakePlayList_ShiftJIS(ObjectId, ObjectName, OutputDir)
    Call MakePlayListSub(ObjectId, ObjectName, OutputDir, "Shift_JIS", False)
End Sub
Sub MakePlayList_UTF8(ObjectId, ObjectName, OutputDir)
    Call MakePlayListSub(ObjectId, ObjectName, OutputDir, "UTF-8", False)
End Sub
Sub MakePlayList_UTF8N(ObjectId, ObjectName, OutputDir)
    Call MakePlayListSub(ObjectId, ObjectName, OutputDir, "UTF-8", True)
End Sub
Sub MakePlayListSub(ObjectId, ObjectName, OutputDir, CharSetString, optDeleteBOM)
    Dim sql
    Dim OutputFileName
    Dim OutputFullPath
    Dim vntKey
    Dim strPath
    Dim dicMusicFilePath
    Dim vnt
    Dim vntExt
    Dim dicExt
    Dim buf
    '
    Set dicExt = CreateObject("Scripting.Dictionary")
    Set dicMusicFilePath = CreateObject("Scripting.Dictionary")
    'o͐tpX
    vntExt = ""
    OutputFileName = ObjectName & ".m3u"
    OutputFullPath = fso.BuildPath(OutputDir, OutputFileName)
    'o͐tpXi[
    dicExt.Add vntExt, OutputFullPath
    'vCXgPʂŏ
    sql = "SELECT [500] AS MusicFilePath"
    sql = sql & " FROM t_containment"
    sql = sql & " INNER JOIN q_syncSource"
    sql = sql & " ON t_containment.ChildId = q_syncSource.ObjectId"
    sql = sql & " WHERE t_containment.ParentId = " & ObjectId
    sql = sql & " ORDER BY t_containment.Order"
    With CreateObject("ADODB.Recordset")
        .Open sql, cn, adOpenForwardOnly
        Do While Not .EOF
            strPath = "" & .Fields("MusicFilePath").Value
            dicMusicFilePath.Add dicMusicFilePath.Count, strPath
            'gqʂɃvCXgꍇ
            If ExtSplit <> "" Then
                vnt = LCase(fso.GetExtensionName(strPath))
                For Each vntExt In Split(ExtSplit, ",")
                    If InStr(" " & vntExt & " ", " " & vnt & " ") > 0 Then
                        If Not dicExt.Exists(vntExt) Then
                            OutputFileName = fso.BuildPath(vntExt, ObjectName & "_" & vntExt & ".m3u")
                            OutputFullPath = fso.BuildPath(OutputDir, OutputFileName)
                            dicExt.Add vntExt, OutputFullPath
                        End If
                        Exit For
                    End If
                Next
            End If
            .MoveNext
        Loop
        .Close
    End With
    If dicMusicFilePath.Count > 0 Then
        For Each vntExt In dicExt.Keys
            OutputFullPath = dicExt.Item(vntExt)
            strPath = fso.GetParentFolderName(OutputFullPath)
            If Not fso.FolderExists(strPath) Then
                Call CreateFolder(strPath)
            End If
            With CreateObject("ADODB.Stream")
                .Type = adTypeText
                .CharSet = CharSetString
                'StreamJ
                .Open
                'wb_
                .Writetext "#EXTM3U", adWriteLine
                'pX񏑂
                For Each vntKey In dicMusicFilePath
                    strPath = dicMusicFilePath.Item(vntKey)
                    vnt = LCase(fso.GetExtensionName(strPath))
                    If vntExt = "" Or InStr(" " & vntExt & " ", " " & vnt & " ") > 0 Then
                        If DeleteDriveString Then
                            strPath = Mid(strPath, InStr(strPath, "\") + 1) 'hCu
                        End If
                        .Writetext strPath, adWriteLine
                    End If
                Next
                't@Cۑ
                If optDeleteBOM Then
                    .Position = 0
                    .Type = adTypeBinary
                    .Position = 3
                    buf = .Read
                    .Close
                    'Binaryŏŕۑ
                    .Open
                    .Type = adTypeBinary
                    .Write buf
                End If
                .SaveToFile OutputFullPath, adSaveCreateOverWrite
                'Stream
                .Close
            End With
        Next
    End If
End Sub
Sub CreateFolder(TargetFolder)
    Dim ParentFolder
    ParentFolder = fso.GetParentFolderName(TargetFolder)
    If ParentFolder <> "" Then
        If Not fso.FolderExists(ParentFolder) Then
            Call CreateFolder(ParentFolder)
        End If
    End If
    If Not fso.FolderExists(TargetFolder) Then
        fso.CreateFolder TargetFolder
    End If
End Sub
